// Program bdcy fragmentem rozwizania zadania T4 I stopnia Olimpiady Fizycznej 2015/2016
// Autor: Jacek Jasiak 13 listopada 2015

// Jest to najprostsza wesja, odpowiadajca opisowi w treci rozwizania
//      dodatkowo znajdowane s lokalne minima i maksima i zapisywane do pliku


// Ani wykorzystany algorytm ani kod nie s zoptymalizowane pod wzgldem efektywnoci
// wykres zapisanych wartoci mona wykona uywajc np. arkusza kalkulacyjnego lub programu gnuplot

//Uwaga: B jest bezwymiarow sta oporu, dla parametrw z zadania B=10*b

#include <stdio.h>
#include <cmath>

using namespace std;
FILE *f;
FILE *fext;

 int ruch(double B, int n, const char *fpath, const char *fextpath)
{
	double pi = 3.1415926535;
	double alfa = pi/2; //kt odchylenia wahada (alfa) - warto pocztkowa pi/2;
	double a1=pi/2; double a2=pi/2; double t1=0; //zmienne pomocnicze przechowujce poprzednie wartoci
    double Omega = 0; // prdko ktowa (bezwymiarowa) - warto pocztkowa 0
	double T = 0; // czas bezwymiarowy
	double t = 0; // czas w sekundach
	double wspT = sqrt(9.81/1.0); // wspczynnik wicy t z T
	double dT ; // krok czasowy;
	dT = 100*wspT/n;

    f=fopen(fpath,"w"); //otwiera plik do zapisu;
    fext=fopen(fextpath,"w"); //otwiera plik do zapisu; 
	fprintf(f, "t           alfa        n=  %i B= %.8f \n", n , B); // zapisuje w pliku informacj co oznacza kada z kolumn
	fprintf(fext, "t           abs(alfa)        rodzaj      ; n=  %i B= %.8f ; wartoci odpowiadajce lokalnym maksimom/minimom \n"
	         ,n, B); // zapisuje w pliku informacj, co oznacza kada z kolumn
    int i = 0; 
	do {
      alfa = alfa + Omega*dT/2; 
      Omega = Omega - (sin(alfa) + B*Omega*abs(Omega))*dT;
      alfa = alfa + Omega*dT/2;
      T += dT;
      t = T/wspT;
      fprintf(f, "%.8f   %.8f    \n", t,alfa); // zapisuje t i alfa
      i++;
      // poniej jest rozszerzenie w stosunku do oficjalnego rozwizania - znajdowanie lokalnych minimw i maksimw
      if ((alfa<a1)  and (a1>a2 )){ 
	  fprintf(fext, "%.8f   %.8f        maksimum \n", t1, a1); // zapisuje alfa max i odpowiednie t  
	   }
	  if ((alfa>a1)  and (a1<a2 )){ 
	  fprintf(fext, "%.8f   %.8f        -minimum \n", t1, -a1); // zapisuje -alfa min i odpowiednie t  
	   }
       a2=a1; a1=alfa; t1=t; // zapamituje poprzednie wartoci odchylenia i czasu
     }
	while (i<=n); 
    fclose(f); fclose(fext);  // zamyka pliki
    printf("Koniec");
    return 0;
  
}
int main()
{
   ruch(0.0, 2000, "./T42015wynnum_00_2000.dat", "./T42015wynnum_00_ext_2000.dat");
   ruch(0.0, 4000, "./T42015wynnum_00_4000.dat", "./T42015wynnum_00_ext_4000.dat");
   ruch(0.025, 2000, "./T42015wynnum_0025_2000.dat", "./T42015wynnum_0025_ext_2000.dat");
   ruch(0.025, 4000, "./T42015wynnum_0025_4000.dat", "./T42015wynnum_0025_ext_4000.dat");
   ruch(0.1, 2000, "./T42015wynnum_01_2000.dat", "./T42015wynnum_01_ext_2000.dat");
   ruch(0.1, 4000, "./T42015wynnum_01_4000.dat", "./T42015wynnum_01_ext_4000.dat");

	return 0;
}

